// Copyright 1999 (c) by Perforce Software, Inc.  All rights reserved.
//
// p4wStrBuf_test:
//   Test p4wStrBuf.


// -------------------------------------
// Includes
//
#include <iostream>

#include <p4wp4.h>

#include "p4wStrBuf.h"



// -------------------------------------
// p4wStrBuf test function.
//
int main(int argc, char *argv[])
{
	//
	// Create our sample dictionary.
	StrBufDict dict;
	dict.SetVar(StrRef("aString"), StrRef("aString"));
	dict.SetVar(StrRef("aTime"), StrRef("930854842"));

	//
	// Create our p4wStrBuf and format some strings.
	p4wStrBuf buf;
	cout << buf.Expand(StrRef("string: %aString%"), dict).Text() << endl;

	buf.Clear();
	cout << buf.Expand(StrRef("noString: %noString?not found%"), dict).Text() << endl;

	//
	// Play with time.
	buf.Clear();
	cout << buf.Expand(StrRef("mm/dd/yy: %aTime@*m/*d/*y%"), dict).Text() << endl;

	buf.Clear();
	cout << buf.Expand(StrRef("mm/dd/yyyy: %aTime@*m/*d/*Y%"), dict).Text() << endl;

	buf.Clear();
	cout << buf.Expand(StrRef("*mm*dd*yyyy*: %aTime@***m***d***Y**%"), dict).Text() << endl;

	buf.Clear();
	cout << buf.Expand(StrRef("noTime: %noTime@*m/*d/*Y?not found%"), dict).Text() << endl;
}
