// Copyright 1999 (c) by Perforce Software, Inc.  All rights reserved.
//
// p4wErrorView:
//   The error view.

#ifndef p4wErrorView_H
#define p4wErrorView_H


#include "p4wView.h"


class p4wErrorView : public p4wView {
public:

	p4wErrorView( p4wRequest &Request, 
		const StrBuf &errorText, 
		int blankPage,
		const char *helpType =0,
		const char *helpText =0 );

	virtual ~p4wErrorView();

	//
	// Control item render functions.
	
	virtual void RenderContent();
	virtual void RenderInfo();
	virtual void RenderMenu();
	virtual void RenderCopyright();
	virtual int RenderUpdateOK() { return 1; };


private:

	const StrBuf &fErrorText;
	
	int fBlankPage;
	
	//
	// If present this is the name of the help link
	
	StrBuf fHelpType;
	
	//
	// If present output this help file text on the page
	
	StrBuf fHelpText;
};

#endif // p4wErrorView_H
