//
// Copyright 2004 Perforce Software.  All rights reserved.
//
// This file is part of Perforce - the FAST SCM System.
//
// p4wLoginView:
//   Runs p4 login


#include <stdlib.h>
#include <string.h>

#include <p4wp4.h>

#include "p4wView.h"
#include "p4wLoginView.h"

#include "p4wLoginPane.h"

p4wLoginView::p4wLoginView( p4wRequest & Request )
	: p4wView(Request)
{
	fPasswordError = 0;
}

p4wLoginView::~p4wLoginView()
{
}

void p4wLoginView::Render( int usedashp )
{
	//
	// invokes the 'p4 login' command,
	// optionally with the -p flag
	
	p4wLoginPane loginPane( *this, fRequest );
	
	if( usedashp )
		fRequest.p4Arg( "-p" );
		
	fRequest.p4( "login", 0, 0, &loginPane );

	fRequest.p4Wait();

	fPasswordError = loginPane.fPasswordError;
	if( usedashp )
		fPswdTicket.Set(loginPane.fPswdTicket);
}

